

rollout MainRollout "Importer" width:219 height:105
(
	button Import "Import Model" pos:[44,20] width:129 height:28
	on Import pressed do 
(
		FName = undefined
		FName = GetOpenFileName types:("All Files (*.*)|*.*| MOD  (*.mod)|*.mod|")
--		FName = "E:\DenGame\3dsmax7\scripts\game.raw"
		if (FName != undefined) then
	(
			f = fopen FName "rb"
			if (f != 0) then 
						
--f = fopen "D:\5388" "rb"
clearlistener()

Face_array=#()
Vert_array=#()
dr=0



--UV_array=#()
NumV=ReadLong f 
OffsV=ReadLong f 

NumMTA=ReadLong f 
OffsMTA=ReadLong f 

NumFaces=ReadLong f 
OffsFaces=ReadLong f

Scale=ReadShort f
MTA2=ReadShort f 


fseek f OffsV #seek_set

--count=6
print ("Vertices = " + NumV as string)
print ("MTA = " + NumMTA  as string)
print ("Faces = " + NumFaces  as string)
print ("Scale = " + Scale  as string)
print ("MTA2 = " + MTA2 as string + "   0x"+ bit.intAsHex(MTA2) as string)
print ("Faces Offset = " + OffsFaces as string + "   0x"+ bit.intAsHex(OffsFaces) as string)



for x = 1 to NumV do
(

vx=readshort f 
vy=readshort f 
vz=readshort f 

vbd=readshort f 



--p4=readfloat f
--p5=readfloat f
--p6=readfloat f
--tu=readfloat f
--tv=readfloat f
--p9=readshort f
--p10=readshort f
--p11=readshort f
append Vert_array[vz / Scale,vx / Scale,vy / Scale]
--append UV_array[tu,tv,0]
)



--count=4
fn ReadFaces f =
(
mt1 = readbyte f
mt2 = readbyte f
mt3 = readbyte f

HEADER = readbyte f


if ( HEADER == 0 ) then      -- 00000000
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000000"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 1 ) then      -- 00000001
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000001"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 4 ) then      -- 00000004
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000004"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 5 ) then      -- 00000005
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000005"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 8 ) then      -- 00000008
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000008"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 9 ) then      -- 00000009
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000009"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 12 ) then      -- 0000000c
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000000c"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 13 ) then      -- 0000000d
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000000d"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 15 ) then      -- 0000000f
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000000f"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 19 ) then      -- 00000013
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000013"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 21 ) then      -- 00000015
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "00000015"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 28 ) then      -- 0000001c
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000001c"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 29 ) then      -- 0000001d
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000001d"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 31 ) then      -- 0000001f
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000001f"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))
	)
else if ( HEADER == 44 ) then      -- 0000002c
	(
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		ta1=readlong f
		ta1=readlong f
		MAT=readshort f	
		append Face_array[fc,fb,fa]
		print "0000002c"
		Print ("Last Read @ 0x " + bit.intAsHex(HEADER) + " " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
		Print ("TEXTURE ID 0x " + bit.intAsHex(MAT))

	)



)
--print count
fseek f OffsFaces #seek_set

for x = 1 to NumFaces do
(
dr = dr+1
print dr as string
ReadFaces f
print ""

)
--Print ("Last Read @ 0x " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )



msh = mesh vertices:Vert_array faces:Face_array
--msh.numTVerts = UV_array.count
--buildTVFaces msh
msh.name=FName



--Print ("Last Read @ 0x " + bit.intAsHex(fa-1) as string + "00 " + bit.intAsHex(fb-1) as string + "00 " + bit.intAsHex(fc-1) as string + "00" )
gc()
fclose f
print FName
print "OK!"
)
)
)
CreateDialog  MainRollout